/* Sample Verilog HDL program */
`timescale 1ns / 1ps   // use for ISM or iverilog
// For ISM make test_mynand the top level entiriy
// For Quartus waveform simulator use mynand as top level
// For iverilog test_mynand will run and envoke the display calls.

/* create a NAND gate out of an AND and an Invertor */
module mynand (xout, ain, bin);
  // define port signals:
  output xout;
  input ain, bin;
  // an internal wire:
  wire w1;
  // instantiate logic gates
  and a1(w1, ain, bin); // w1 is an output = ain AND bin
  not n1(xout, w1); // wire w1 connects via NOT to xout
endmodule

/* Create a test bench for the nand gate  -- use for ISIM */
module test_mynand (w); // no ports defined
  // defined registers and wire
  reg rega, regb;
  output w;

  // instantiate the module 
  mynand testinst (w, rega, regb);

  //Behavioral code block generates stimulus to test circuit
  initial 
    begin
      rega = 1'b0; regb = 1'b0;
      #50 $display("A = %b, B = %b, Nand output w = %b \n", rega, regb, w);
      rega = 1'b0; regb = 1'b1;
      #50 $display("A = %b, B = %b, Nand output w = %b \n", rega, regb, w);
      rega = 1'b1; regb = 1'b0;
      #50 $display("A = %b, B = %b, Nand output w = %b \n", rega, regb, w);
      rega = 1'b1; regb = 1'b1;
      #50 $display("A = %b, B = %b, Nand output w = %b \n", rega, regb, w);
    end
    
endmodule
